diff --git a/src/DMD5_fmt_plug.c b/src/DMD5_fmt_plug.c
index 17913ed1e0..330c29129a 100644
--- a/src/DMD5_fmt_plug.c
+++ b/src/DMD5_fmt_plug.c
@@ -157,6 +157,8 @@ static int valid(char *ciphertext, struct fmt_main *self)
 	data = p + 1; // cnonce
 	if (!(p = strchr(data, '$')) || (int)(p-data) > MD5_HEX_SIZE)
 		return 0;
+	if ( abs(hexlenl(data)) != p-data)
+		return 0;
 	data = p + 1; // nc
 	if (!(p = strchr(data, '$')) || (int)(p-data) >= 9)
 		return 0;
@@ -172,6 +174,8 @@ static int valid(char *ciphertext, struct fmt_main *self)
 			return 0;
 	} else if (strlen(data) > MD5_HEX_SIZE)
 		return 0;
+	if (hexlenl(data) !=strlen(data))
+		return 0;
 
 	return 1;
 }
diff --git a/src/common.c b/src/common.c
index 68ca4c27e7..9e5cc68fc3 100644
--- a/src/common.c
+++ b/src/common.c
@@ -140,10 +140,10 @@ static MAYBE_INLINE int _hexlen(char *q, unsigned char dic[0x100])
 	size_t len = strlen(q);
 	if (len&1) --len;
 
-	while (atoi16[ARCH_INDEX(*q)] != 0x7F)
+	while (dic[ARCH_INDEX(*q)] != 0x7F)
 		++q;
 	if ((size_t)(q - s)&1) --q;
-	return (len == (size_t)(q - s)) ? (int)(q - s) : -1 - (int)(q - s);
+	return (len == (size_t)(q - s)) ? (int)(q - s) : 0 - (int)(q - s);
 }
 int hexlen(char *q)
 {
